#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dpDetailsProc.tcl,v 1.1 2004/09/06 14:47:14 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  03/07/98  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#Initialise panel
proc dpDetailsInitX {} {
    global gvar CV detailsCV cv

    set detailsCV $cv
    #Build the listbox headers
    set formatLine "%-41s %-13s %-10s"
    set formatHeader "\" Task Name\" \"Received on\" Info" 
    set gvar(dpDetailsHdr) [eval format [concat \"$formatLine\" $formatHeader]]
    set gvar(detailsFlag) 1
}

#Just close the panel
proc dpDetailsClosePanel {} {
    global gvar detailsCV
    
    set gvar(detailsFlag) 0
    panClosePanel no .dpDetails

}

#Update the list by querying the database.
proc dpDetailsQuery {} {
    global gvar detailsCV env sybmsg


    set detailsList ""
    set gvar(detailsAttrib) ""
    set formatLine "%-40s %-13s %-10s"

    
    . config -cursor watch
    update; update idletasks
    
    set select "select task_name, convert(char(8), creation_date, 108) ,status , info, error_msg
    from olas_log
    where file_id = '$gvar(dpID)'"
    
    set dataProducts [Sybsql $select]
        
    Debug "dpDetails, this is the select: $select" 1
    
    if {$dataProducts == "error" } { return }
    Debug "dpDetails, this is the result from select: $dataProducts" 3
    
    foreach entries $dataProducts {
	update; update idletasks
	set task_name   [string range [file rootname [lindex $entries 0]] 0 40 ]
	set date        [lindex $entries 1]
	set status      [lindex $entries 2]
	set info        [lindex $entries 3]
	set errormsg    [lindex $entries 4]

	Debug "task_name = $task_name" 1
	Debug "date      = $date"      1
	Debug "status    = $status"    1
	Debug "info      = $info"      1
	Debug "error_msg = $errormsg"  1

	if {$status == "E"} {lappend gvar(detailsAttrib) "red"
	    set info $errormsg
	} else {lappend gvar(detailsAttrib) "normal"}
	set formatHeader "\"$task_name\" \"$date\"  \"$info\""
	lappend detailsList [eval format [concat \"$formatLine\" $formatHeader]]
    }
    
    Debug "dpDetails list: $detailsList" 3
    $detailsCV.dpDetailsListWdg deleteItem 0 end
    $detailsCV.dpDetailsListWdg addItemList 0 $detailsList
    dpDetailsAttrib
    . config -cursor top_left_arrow
    update; update idletasks
}


#Procedure to define colours of entries
proc dpDetailsAttrib {} {
    global gvar detailsCV

    set indx 0
    foreach attrib $gvar(detailsAttrib) {
	if {$attrib == "overstrike"} {set option "-overstrike 1"
	} elseif {$attrib == "normal"} {set option ""
	} else { set option "-foreground $attrib"}
	eval [$detailsCV.dpDetailsListWdg component uifFancyListBox] item configure $indx $option
	incr indx +1
    }
}
