#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: dpViewerProc.tcl,v 1.1 2004/09/06 14:47:14 cguirao Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# fsogni  03/07/98  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc dpViewerInitX {} {
    global gvar dpCV sybmsg cv env

    #Load Sybase-tcl libraries
    if {[catch {package require Sybtcl}]} {Info "I cannot load Sybtcl.\nPlease check the library path or call the operator."; exit }

    Debug "dpViewer loads Sybtcl" 3
    
    #Keep the original cv variable
    set dpCV $cv
    #Build the listbox headers
    set formatLine "%-36s %-35s %-6s"
    set formatHeader "\" Data Product\" Original VDFPUA" 
    set gvar(dpViewerHdr) [eval format [concat \"$formatLine\" $formatHeader]]
    #set some flags and variables
    set gvar(detailsFlag) 0
    set gvar(dpExpStartFrom) "[clock format [clock seconds] -format "%Y-%m-%d" -gmt 1]"
    set gvar(dpList) ""
    set gvar(dpIdArray) ""
    set gvar(dpAttrib) ""
    set gvar(start_t) $gvar(dpExpStartFrom)
    set gvar(dpExpStartTo)   ""
    set gvar(dpCancelLoop) 0
    set gvar(tmpToDate)      ""
    set gvar(dpUpdateTimeRate) 10000
    set gvar(dpUpdateTime)    10
    set gvar(dpViewerGo)       0
    set gvar(queryCancelled) 0
    set gvar(dpEntriesFlag)    0
    set gvar(dateFlag) 0
    set gvar(newQuery) 1

    #set the bindings 
    $dpCV.dpViewerListWdg setBind <Button-1> {showDetails}
    bind $dpCV.dpExpStartFromWdg.uifEntry  <Return> {dpViewerQuery}
    bind $dpCV.dpExpStartFromWdg.uifEntry  <Any-Key> {set gvar(dateFlag) 1}
    bind $dpCV.dpExpStartToWdg.uifEntry  <Return> { dpViewerQuery }

    bind $dpCV.dpViewerCancelWdg.uifButton <Enter> {dpArrowCursor}
    bind $dpCV.dpViewerCancelWdg.uifButton <Leave> {dpWatchCursor}
    bind $dpCV.dpViewerQuitWdg.uifButton <Enter> {dpArrowCursor}
    bind $dpCV.dpViewerQuitWdg.uifButton <Leave> {dpWatchCursor}
    $dpCV.dpUpdateTimeWdg enable
    

    #Get the sybase username and passwor
    set gvar(db_server) $env(DSQUERY)
    set gvar(database) observations
    if {[catch {set sybaseLogin [exec dbrcGet $gvar(db_server) $gvar(database)]} var]} {Info "I cannot get the DB password.\nCall the operator."; exit }
    set gvar(sybaseUsername) [lindex $sybaseLogin 0]
    set gvar(sybasePassword) [lindex $sybaseLogin 1]

    Debug "user name: $gvar(sybaseUsername)" 1
    
    #Check Sybase connectivity
    if {[catch {set sybHandle [sybconnect $gvar(sybaseUsername) $gvar(sybasePassword) $gvar(db_server)]} handle]} {Info "Cannot connect to server, reason: $sybmsg(dberrstr)"
	puts "Cannot connect to server, reason: $sybmsg(dberrstr)"
	exit 
    }
    sybclose $sybHandle
    dpLoop dpViewerCheckLoop
}


proc dpViewerCheckLoop {} {
    global gvar

    if {$gvar(dpAutoUpdate) == 0} { return }
    if {$gvar(dpExpStartTo) != ""} { return }
    dpViewerQuery
}


#Update the list by querying the database.
proc dpViewerQuery {} {
    global gvar dpCV env sybmsg
    
    if {$gvar(dpViewerGo)} { return }
    if {[checkDate $gvar(dpExpStartFrom) $gvar(dpExpStartTo)] == 1} { return }
    
    #$dpCV.dpViewerListWdg deleteItem 0 end
    #$dpCV.dpViewerListWdg addItem 0 "Quering the database..."
    #update

    #set gvar(dpAttrib) ""
    #set gvar(dpIdArray) ""
    if {$gvar(dateFlag) ==  1} {
	set gvar(start_t) $gvar(dpExpStartFrom)
	set gvar(dpList) ""
	set gvar(dpAttrib) ""
	set gvar(dpIdArray) ""
	set gvar(dateFlag) 0
	set gvar(newQuery) 1 }

    set formatLine "%-35s %-35s %6s"
    set dpExpStartTo $gvar(dpExpStartTo)
        
    
    if {$gvar(dpExpStartTo) == ""} {set dpExpStartTo [clock format [clock seconds] -format "%Y-%m-%d" -gmt 1]}
    
    dpViewerDisableEntries
    . config -cursor watch
    .dpViewer.bot.sh displayText "Querying the database..."
    update; update idletasks
    set gvar(dpViewerGo) 1
    set gvar(queryCancelled) 0

    #This is the query.
    # #set select "select substring(x.file_id,1,125), substring(y.info,1,125),
#      sum(x.ctrl_mask), sum(ascii(x.status)-78)/count(*)
#      from olas_log x, olas_log y
#      where x.file_id*=y.file_id and x.file_type=1 and y.task_type=0
#      and x.creation_date >= '$gvar(dpExpStartFrom)' and x.creation_date <= '$dpExpStartTo 11:59PM'
#      group by substring(x.file_id,1,125), substring(y.info,1,125)
#      order by substring(x.file_id,1,125) desc"

    #Before there was an "order by  x.creation_date" at the end of the
    # query.
    set select "select substring(x.file_id,1,125), substring(y.info,1,125),
     sum(x.ctrl_mask), sum(ascii(x.status)-78)/count(*), convert(char(35), x.creation_date, 9)
     from olas_log x, olas_log y
     where x.file_id*=y.file_id and x.file_type=1 and y.task_type=0
     and x.creation_date >= '$gvar(start_t)' and x.creation_date <= '$dpExpStartTo 11:59PM'
     group by substring(x.file_id,1,125), substring(y.info,1,125)"

    Debug "Send this select: $select" 1
    set dataProducts [Sybsql $select]
    Debug "Result from dpViewer select: $dataProducts" 3
    
    if {$dataProducts == "error" } {  
	.dpViewer.bot.sh displayText "Database error !"
    	dpViewerEnableEntries
	return }    
    
    #Extract the information from the query.
    foreach entries $dataProducts {
	update; update idletasks
	set dpFile   [string range [file rootname [lindex $entries 0]] 0 34]
	set origFile [string range [file rootname [lindex $entries 1]] 0 34]
	set numdots  [lindex $entries 2]
	set errFlag  [lindex $entries 3]
	set creationDate [lindex $entries 4]
	
	Debug "DP File: $dpFile" 1
	Debug "Orig: $origFile"  1
	Debug "Dots: $numdots"   1
	Debug "Err: $errFlag"    1
	Debug "Date: $creationDate" 1


	#set dots [replicate "o" $numdots]
	regsub -all "0" $numdots " " tmpdots
	regsub -all {[1-9]} $tmpdots "o" dots
	
	#See if the dpFile is already in the list
	set index [lsearch -exact $gvar(dpIdArray) [lindex $entries 0]]
	
	if { $index == -1 } {
	    lappend gvar(dpIdArray) [lindex $entries 0]
	    if {$errFlag != 1} {lappend gvar(dpAttrib) "red"
	    } else {lappend gvar(dpAttrib) "normal"}
	    set formatHeader "\"$dpFile\" \"$origFile\" \"$dots\""
	    lappend gvar(dpList) [eval format [concat \"$formatLine\" $formatHeader]]
	    if {$gvar(newQuery) == 0} {$dpCV.dpViewerListWdg addItem end [eval format [concat \"$formatLine\" $formatHeader]]
		set attrib [lindex $gvar(dpAttrib) [$dpCV.dpViewerListWdg getSize]]
		if {$attrib == "overstrike"} {set option "-overstrike 1"
		} elseif {$attrib == "normal"} {set option ""
		} else { set option "-foreground $attrib"}
		eval [$dpCV.dpViewerListWdg component uifFancyListBox] item configure $index $option
	    }
	    Debug "dpfile = $dpFile -- orig = $origFile -- number = $numdots" 2
	} else { 
	    if {$errFlag != 1} {lreplace $gvar(dpAttrib) $index $index "red"
	    } else {lreplace $gvar(dpAttrib) $index $index "normal"}
	    set formatHeader "\"$dpFile\" \"$origFile\" \"$dots\""
	    lreplace $gvar(dpList) $index $index [eval format [concat \"$formatLine\" $formatHeader]]
	    Debug "dpfile = $dpFile -- orig = $origFile -- number = $numdots" 2
	    #set here the new start_t
	    if {$gvar(newQuery) == 0} {$dpCV.dpViewerListWdg deleteItem $index $index 
		$dpCV.dpViewerListWdg addItem $index [eval format [concat \"$formatLine\" $formatHeader]]
		set attrib [lindex $gvar(dpAttrib) $index]
		if {$attrib == "overstrike"} {set option "-overstrike 1"
		} elseif {$attrib == "normal"} {set option ""
		} else { set option "-foreground $attrib"}
		eval [$dpCV.dpViewerListWdg component uifFancyListBox] item configure $index $option
		update; update idletasks
	    }
	    if {$gvar(queryCancelled)} { break }
	}
	set num [$dpCV.dpViewerListWdg getSize]
		set pos [expr {$num - 24}]
	[$dpCV.dpViewerListWdg component uifFancyListBox] yview $pos
	update; update idletasks

	set gvar(start_t) $creationDate
    }
    
    Debug "dpViewer list: $gvar(dpList)" 3
	if {$gvar(dpList) == ""} { set gvar(dpList) {{No entries...}}
	    set gvar(dpEntriesFlag) 1
	} else { set gvar(dpEntriesFlag) 0 }
	
    if {$gvar(newQuery)} {
		$dpCV.dpViewerListWdg deleteItem 0 end
		$dpCV.dpViewerListWdg addItemList 0 $gvar(dpList)
		set num [$dpCV.dpViewerListWdg getSize]
		set pos [expr {$num - 24}]
		[$dpCV.dpViewerListWdg component uifFancyListBox] yview $pos
		update; update idletasks
		set gvar(newQuery) 0
		dpViewerAttrib
    }
    
    if {$gvar(dpAutoUpdate) == 0} { dpViewerEnableEntries }
    . config -cursor top_left_arrow
    .dpViewer.bot.sh displayText ""
    set gvar(dpViewerGo) 0
}


#Procedure to define colours of entries
proc dpViewerAttrib {} {
    global gvar dpCV

    set indx 0
    foreach attrib $gvar(dpAttrib) {
	if {$attrib == "overstrike"} {set option "-overstrike 1"
	} elseif {$attrib == "normal"} {set option ""
	} else { set option "-foreground $attrib"}
	
	eval [$dpCV.dpViewerListWdg component uifFancyListBox] item configure $indx $option
	incr indx +1
    }
}

#Click an entry and get another panel showing the details.
proc showDetails {} {
    global gvar dpCV
    
    #set selected [string trim [$dpCV.dpViewerListWdg getSelection] "{}"]
    set selected [$dpCV.dpViewerListWdg getIndex]
    if {$selected == "" || $gvar(dpEntriesFlag) == 1  } { return }
    set gvar(dpID) [lindex $gvar(dpIdArray) $selected]
    if {$gvar(detailsFlag) == "0"} {panImportPanel dpDetails} 
    if {$gvar(detailsFlag)} { dpDetailsQuery }
}

#Just close the panel.
proc dpViewerClosePanel {} {
    
    #Execute close, clean, whatever procedure before exiting
    exit
}

#Pop up a window with messages
proc dpViewerPopUp { mess1 yesflag okflag noflag } {
    global errorInfo popflag
    set w .dpViewerPopUp

    if {[winfo exists $w]} { destroy $w }

    set title  "Dialog Box"

    # Determine an estimate of the window width

    set len       [string length $mess1]
    set msgWidth  "8i"
    if {[set idx [string first "\n" $mess1]] != -1 } {
        set len $idx
    }

    if {$len > 36 } { set msgWidth "12i" }

    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog

    frame $w.top -relief raised -bd 1
    frame $w.bot -relief raised -bd 1

    #label $w.lbl1 -text "Tcl/Tk Error Stack" \
        #              -font "-Adobe-helvetica-bold-r-normal--14*"

    #UifText $w.stack -width 36 -height 8 \
        #                 -font "-Adobe-courier-medium-r-normal--12*"

    pack $w.top            -fill both
    #pack $w.lbl1  -pady 5  -fill x
    #pack $w.stack -pady 3  -expand yes -fill x
    pack $w.bot            -expand yes -fill x
    
    #$w.stack insertText 0.0 $errorInfo
    
    #
    # Fill the top part with bitmap and message.
    #
    
    message $w.msg -width $msgWidth  -text $mess1 \
        -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 5m -pady 5m
    
    #
    # Create a row of buttons at the bottom of the dialog.
    #
    frame $w.bottoni -relief sunken -bd 1
    button $w.bottoni.yes -text YES -command "set popflag 1"

    button $w.bottoni.ok -text OK -command "set popflag 2"
    button $w.bottoni.no -text NO -command "set popflag 0"
    pack -after $w.bottoni $w.bottoni.yes {left expand fillx padx 30} \
        $w.bottoni.ok {left expand fillx padx 30} \
        $w.bottoni.no {left expand fillx padx 30}
    pack -after $w $w.bottoni {top fill}

    if {$yesflag == 1} {$w.bottoni.yes configure -state normal
    } else {$w.bottoni.yes configure -state disabled}

    if {$okflag == 1} {$w.bottoni.ok configure -state normal
    } else {$w.bottoni.ok configure -state disabled}

    if {$noflag == 1} {$w.bottoni.no configure -state normal
    } else {$w.bottoni.no configure -state disabled}

    update idletasks

    # Set a grab and claim the focus too.

    if {$okflag == 0} {
	set oldFocus [focus]
	grab $w ; focus $w}


    # Set Geometry to allow the user to re-size only along X

    set geo    [wm geometry $w]
    scan $geo "%dx%d+%d+%d" wid hei posx posy

    wm minsize $w $wid $hei
    wm maxsize $w 1000 $hei
    #
    # Wait for the user to respond, then restore the focus and
    # return the index of the selected button.
    #
    
    tkwait variable popflag
    destroy $w
    return $popflag
    
}

proc showFlags {} {
    global dpCV

        set txt {
V = Vcs Olac
D = DHS
F = Frameingest
P = Pipeline
U = User Workstation
A = Asto}

    #$dpCV.dpViewerListWdg deleteItem 0 end
    #$dpCV.dpViewerListWdg addItemList 0 $txt
    Info $txt
}

proc dpAUToggle {} {
    global gvar dpCV

    if {$gvar(dpAutoUpdate) == 1} {
	set gvar(dpAutoUpdate) 0
	set gvar(tmpToDate) $gvar(dpExpStartTo)
	set gvar(dpExpStartTo) ""
	
	if {[checkDate $gvar(dpExpStartFrom) $gvar(dpExpStartTo)] == 1 \
		|| [regexp  {^[0-9]+$} $gvar(dpUpdateTime)] == 0 \
		|| $gvar(dpUpdateTime) >999 \
		|| $gvar(dpUpdateTime) < 1 } {
	    Info "Auto Update not started.\nCheck From: and the refresh rate"
	    set gvar(dpExpStartTo) $gvar(tmpToDate)
	    $dpCV.dpExpStartToWdg enable
	    $dpCV.dpExpStartFromWdg enable
	    dpAUToggle
	} else {
	    set gvar(dpAutoUpdate) 1
	    dpViewerDisableEntries
	    set gvar(dpUpdateTimeRate) [expr {$gvar(dpUpdateTime) * 1000}]
	    }
    } else {
	set gvar(dpExpStartTo) $gvar(tmpToDate)
	dpViewerEnableEntries
    }
}


proc dpViewerEnableEntries {} {
    global dpCV
    
    $dpCV.dpExpStartToWdg enable
    $dpCV.dpExpStartFromWdg enable
    $dpCV.dpUpdateTimeWdg enable
    $dpCV.dpViewerQueryWdg enable
}

proc dpViewerDisableEntries {} {
    global dpCV
    
    $dpCV.dpExpStartToWdg disable
    $dpCV.dpExpStartFromWdg disable
    $dpCV.dpUpdateTimeWdg disable
    $dpCV.dpViewerQueryWdg disable

}





#Loop routine.
proc dpLoop { cmd  } {
  global gvar

    if {$gvar(dpCancelLoop) == 1} {
	set gvar(dpCancelLoop) 0
	after cancel $gvar(loopId)
	#puts  "$type Loop - $gvar(loopId-$type) killed " 
    } else {
	eval $cmd
	set gvar(loopId) [after  $gvar(dpUpdateTimeRate)  dpLoop \"$cmd\" ]
	#puts "LoopID = $gvar(loopId-$type) -- cmd = $cmd" 
    }
}

#Parse the arguments from the command line and set some options
proc dpSetOptions {} {
    global gvar

    for { set i 0} {$i <[llength $gvar(args)]} {incr i} {
		switch -- [lindex $gvar(args) $i] {
			-info {
				incr i
				dpExplainAll} 
			-debug {
				incr i
				set level [lindex $gvar(args) $i]
				if {$level == "" || $level > 3 || $level < 1} {
					dpExplain}
				set gvar(debugMode) $level} 
			-log {
				incr i
				set logFile [lindex $gvar(args) $i]
				if {[catch {set gvar(logFile) [open $logFile a]} var]} {
					puts "Cannot open $logFile"
					exit}
			} 
			default {
				dpExplain
			}
		}
    }
}

#I won't explain explain =;-)
proc dpExplain {} {
    
    puts "Usage: dpViewer -info -log <filename> -debug \[1-3\]"
    exit
}



proc dpExplainAll {} {
    puts "-info           : This message"
    puts "-log <filename> : Puts all the messages in the specified file"
    puts "                : If you don't specify -debug the verbose level"
    puts "                : will be set to 1"
    puts "-debug \[1-3\]    : Define the verbose level"
    exit
}

proc dpWatchCursor {} {
    global gvar

    if {$gvar(dpViewerGo)} {
	. config -cursor watch
        update
        update idletasks
    }
    
}

proc dpArrowCursor {} {
    global gvar

    if {$gvar(dpViewerGo)} {
	. config -cursor top_left_arrow
        update
        update idletasks
    }
    
}


#
# ___oOo___
