package org.eso.dfs.util;

/**
 * @author nkornwei
 *
 * An interface used to listen for KeywordTokens from a FitsTokenizer.
 * This interface must be implemented and added to the FitsTokenizer 
 * through addKeywordListener().
 */
public interface KeywordListener {

    /**
     * Called when a KeywordToken has been read.
     * @return boolean true to instruct the FitsTokenizer
     * to continue reading, and false to stop reading.
     */
    public boolean tokenRead(KeywordToken kwt);

}
