/**
 * class DBContainer
 *
 * adds just the bit necessary to 
 * the SortedHashtable, in order to 
 * be used for Tree representation<p>
 * 
 * it is thought as a replacement of 
 * Program and Observation in the
 * DFSFile world.<p>
 * 
 * a char variable is used to keep track of the
 * type of this container<p>
 * @author: Michele Zamparelli
 * @see: SortedHashtable
 * @see: Prorgram, Observation
 */

package org.eso.gasgano.datamodel.database;

import org.eso.gasgano.tools.SortedHashtable;

public class DBContainer extends SortedHashtable {
    private DBContainer father = null;
    private int filesCount = 0;
    private String desc = null;

    private char containerType = 'a';

    public DBContainer() {
        super();
    }

    public DBContainer(char type, String label) {
        super(label);
        setDescription(label);
        containerType = type;
    }

    public void setFather(DBContainer f) {
        father = f;
    }

    public DBContainer getFather() {
        return father;
    }

    public boolean isProgram() {
        if (containerType == 'p') {
            return true;
        }
        return false;
    }

    public boolean isTelescope() {
        if (containerType == 't') {
            return true;
        }
        return false;
    }

    public boolean isObservation() {
        if (containerType == 'o') {
            return true;
        }
        return false;
    }

    public void setDescription(String s) {
        desc = s;
    }

    /**
     * this method is used in particular for the 
     * visualization of the Observation as a JLabel component,<p>
     * therefore it must contain more than the mere id number<p>
     */

    public String toString() {
        return desc;
    }

    /**
     * @return: the identification number for this observation
     *
     */

    public String getId() {
        return super.toString();
    }

    public void setVirtualSize(int size) {
        filesCount = size;
    }

    public int virtualSize() {
        if (filesCount < super.size()) {
            return super.size();
        }
        return filesCount;
    }
}
