/**
 * @author N. Kornweibel
 * @version 1.0
 * The not equivalence (!=) binary expression.
 */

package org.eso.gasgano.keyword;

public class NEqKeywordExpr extends BinaryKeywordExpr {

    static final long serialVersionUID = -7387657104792205710L;
    
    public static final String opString = "!=";

    /**
     * @param l The left hand value.
     * @param r The right hand value.
     */
    public NEqKeywordExpr(Object l, Object r) {
        super(l, r);
    }

    public boolean eval(float l, float r) {
        return (l != r);
    }
 
    public boolean eval(String l, String r) {
        return !l.equals(r);
    }

    public String getOpString() {
        return opString;
    }
    /**
     * @see org.eso.gasgano.keyword.DefaultBoolKeywordExpr#copy()
     */
    public DefaultBoolKeywordExpr copy() {
        DefaultBoolKeywordExpr rc = new NEqKeywordExpr(getLeftValue(), getRightValue());
        return rc;
    }
}
