/**
 * @author N. Kornweibel
 * @version 1.0
 * The notlike operator !equivalence with the option of using a "*" wild
 * card in the RHS String.
 */

package org.eso.gasgano.keyword;

public class NotLikeKeywordExpr extends LikeKeywordExpr {

    static final long serialVersionUID = -2800013022383662211L;
    
    public static final String opString = "notlike";

    /**
     * @param l The left hand value.
     * @param r The right hand value.
     */
    public NotLikeKeywordExpr(Object l, Object r) {
        super(l, r);
    }

    /**
     * Return the not value of the LikeKeywordExpr.evaluate().
     */
    public boolean evaluate(KeywordSet s) 
            throws ExpressionEvaluationException {
        return (!super.evaluate(s));
    }

    public String getOpString() {
        return opString;
    }
    
    /**
     * @see org.eso.gasgano.keyword.DefaultBoolKeywordExpr#copy()
     */
    public DefaultBoolKeywordExpr copy() {
        DefaultBoolKeywordExpr rc = new NotLikeKeywordExpr(getLeftValue(), getRightValue());
        return rc;
    }

}
// end of file NotLikeKeywordExpr.java
