/*
 * Created on Aug 1, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.eso.ohs.core.dbb.server;

import java.sql.SQLException;

import org.eso.ohs.core.dbb.sql.DbbSqlQueryChunks;

/**
 * @author ddorigo
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DbbSqlEngineUnionImpl extends DbbSqlEngineImpl {

	/**
	 * @param session
	 * @param b
	 */
	public DbbSqlEngineUnionImpl(DbbSession session, boolean b) throws SQLException {
		super(session,b);
	}
	/**
	 * @param db_session
	 * @throws SQLException
	 */
	public DbbSqlEngineUnionImpl(DbbSession db_session) throws SQLException {
		super(db_session);
		
	}
	/**
	  * Create and start a thread to get the result set and to process it
	  * into an Object array
	  *
	  * @param sql       Sql statement
	  * @exception SQLException if a jdbc call throws an excpetion
	  */
	 public DbbQuery startQuery(DbbSqlQueryChunks chunks, DbbSqlQueryChunks chunksUnion) throws SQLException {

		// the sorting and grouping in this
		 String sqlPrincipal = this.sqlBuildQuery(chunks, false);
		 
         String sqlUnion = this.sqlBuildUnionQuery(chunksUnion, false);
         StringBuffer sql = new StringBuffer().append(sqlUnion).append(" UNION ").append(sqlPrincipal); 
		 /* Create and start the thread. */
		  stdlog_.debug(sql);
		 return execSql(sql.toString());
	 }
	 
	/**
	  * Build an SQL query based on the default chunks as well as sume
	  * new chunks passed as parameters. Note that default chunks take
	  * precedence (they are processed first). The group and sorting is not considered
	  *
	  * @param columns   List of chunks: columns to retrieve
	  * @param rows      List of chunks: rows to retrieve
	  * @param rows      List of chunks: sort columns
	  * @param group     List of chunks: "group by" columns
	  * @param isCount   Boolean flag to indicate if it is only a sql count statement
	  * @exception SQLException if a jgbc call throws an excpetion
	  */
	 public String sqlBuildUnionQuery(DbbSqlQueryChunks chunks, boolean isCount)
		 throws SQLException {

		 /* Initialize table and clause lists */
		 tablesClear();
		 whereClausesClear();

		 String sql = "";
		 String sqlSELECT = "";
		 String sqlFROM = "";
		 String sqlWHERE = "";

		 /* Add defaults chunks */
		 chunks.columns = concatenate(defColumns_, chunks.columns);
		 chunks.rows = concatenate(defRows_, chunks.rows);
		 chunks.sort = concatenate(defSort_, chunks.sort);
		 chunks.group = concatenate(defGroup_, chunks.group);

		 // @author amchavan, 10-Jun-2002: commented out
		 // if(stdlog_.isDebugEnabled())
		 //     dumpchunks("buildSQL", chunks.columns, chunks.rows,
		 //         chunks.sort, chunks.group);

		 /* Precompute list of needed tables. More (join) tables might be
		  * added later
		  */
		 tablesCompute(chunks.columns, chunks.rows, chunks.sort, chunks.group);

		 // @author amchavan, 10-Jun-2002: commented out
		 // if(stdlog_.isDebugEnabled())
		 //   dumptables("Precomputed tables");

		 /* The SELECT, SORT and GROUP BY clauses depend on the default
		  * chunks and those chunks activated by the user
		  */
		 sqlSELECT = sqlBuildSELECT(chunks.columns, isCount);

		

		 /* Extract all needed WHERE clauses from the widgets in the row
		  * selection panel
		  */
		 computeRowSelectionClauses(chunks.rows);

		 /* Now compute all WHERE join clauses, based on the list of all
		  * needed tables
		  */
		 computeTableJoinClauses();

		 // @author amchavan, 10-Jun-2002: commented out
		 //if(stdlog_.isDebugEnabled())
		 //    dumptables("Join tables");

		 sqlWHERE = sqlBuildWHERE();

		 /* The FROM clause lists all tables about which we found out so
		  * far: default chunks, chunks activated by the user, join
		  * tables
		  */
		 sqlFROM = sqlBuildFROM();

		 sql =
			 sqlSELECT
				 + "\n"
				 + sqlFROM
				 + "\n"
				 + sqlWHERE
				 + "\n";

		 stdlog_.debug(sql);

		 return sql;
	 }

}
