package org.eso.ohs.core.gui.models;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
/**
 * A Document model to only permit the input of an epoch.
 * 
 * <p>
 * $Id: GradeModel.java,v 1.1 2004/02/17 10:35:21 tcanavan Exp $
 */

public class GradeModel extends InputMaskModel {

    /**
     * The regular expression describing legal buffer values.
     * Looking for values like: 1.0
     */
    private final static String legalValuesPattern_ =
	"[1-5]?(\\.\\d{0,1})?";

    /**
     * Constructor for the model.
     */
    public GradeModel() { 
	super(legalValuesPattern_);
    }



    public void insertString(int offset, String str, AttributeSet a)
		throws BadLocationException {

	//stdlog_.debug("String: <"+str+">");

	super.insertString(offset, str, a);

	//stdlog_.debug("buffer: <"+buffer_+">");

	try {
	    String buffer_val = buffer_.toString();
	    Float f = Float.valueOf(buffer_val);

	    if(f.floatValue() > 5) {
		remove(offset, str.length());
	    }		
	    if(f.floatValue() < 1) {
		remove(0, offset+1);
	    }		
	} catch (NumberFormatException e) {
	    // nothing, the string is not complete...
	}
    }
}

