package org.eso.ohs.core.gui.widgets.examples;

import java.awt.BorderLayout;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;

/**
 * Third page of the example wizard.
 * 
 * @version $Revision: 1.2 $
 * @author amchavan, Jul 27, 2005
 */

// $Id: InstallerPage3.java,v 1.2 2005/09/01 13:00:59 ddorigo Exp $
public class InstallerPage3 extends OHSWizardPage {

    JTextField instDir = new JTextField();

    JComboBox instType = new JComboBox();

    /**
     * Default constructor
     */
    public InstallerPage3( OHSWizard wizard ) {
        super( wizard );
        setLayout( new BorderLayout() );
        add( createPanel(), BorderLayout.CENTER );
        listenTo( instType );
        listenTo( instDir );
    }

    public JPanel createPanel() {
        JPanel jpanel1 = new JPanel();

        Box box = Box.createVerticalBox();
        Box box2 = Box.createHorizontalBox();
        Box box3 = Box.createHorizontalBox();

        JLabel jlabel1 = new JLabel();
        jlabel1.setFont( new Font( "Tahoma", Font.BOLD | Font.ITALIC, 14 ) );
        jlabel1.setText( "Step 3: installation parameters" );
        box.add( jlabel1 );

        JLabel jlabel2 = new JLabel();
        jlabel2.setText( "Installation type" );
        box2.add( jlabel2 );

        instType.setName( "instType" );
        instType.addItem( "    " );
        instType.addItem( "Basic" );
        instType.addItem( "Custom" );
        instType.addItem( "Full" );
        box2.add( instType );

        JLabel jlabel3 = new JLabel();
        jlabel3.setText( "Installation directory" );
        box3.add( jlabel3 );

        instDir.setName( "instDir" );
        box3.add( instDir );

        box.add( box2 );
        box.add( box3 );
        jpanel1.add( box );

        return jpanel1;
    }

    /**
     * @return <code>true</code> if the text field is not empty and the
     *         pulldown menu has a valid (i.e. not empty) selection.
     */
    protected boolean isReady() {
        return ((instDir.getText().length() != 0) && (((String) instType
                .getSelectedItem())).trim().length() != 0);
    }

}
