package org.eso.ohs.instruments;

import java.io.File;

/**
 * This is a parameter class which stores the path
 * of a file stored on disk.
 * <p>
 * $Id: FilenameParameter.java,v 1.7 2003/07/03 08:49:49 ddorigo Exp $
 * @author Tim Canavan
 */

public class FilenameParameter extends Parameter {

    static final long serialVersionUID = 7474818534099669707L;

    /**
     * Constructor
     * @param parameterName name of parameter
     */

    public FilenameParameter(ParamMetaData pMeta) {
        super(pMeta);
    }

    /**
     * Return tooltip text for Filename parameter
     */

    public String getToolTipText() {
        return "Select filename";
    }


    public char getDBTypeCode() {
        return 'F';
    }

    /**
     * Verify that the filename is valid
     * @param s filename 
     */
    
    public boolean verifyValue(String s) {
         if(s.equals("NODEFAULT"))
             return false;
         File f = new File(s);
         if(!f.exists())
             return false;    
         if(!f.canRead())
             return false;
         return true;
    }
  

}
