package org.eso.ohs.persistence;

import java.awt.Container;


/**
 *
 * This is a ommon interface to actions that will both operate on Database
 * Browsers and local storage within p2pp. FolderGridView is the class that
 * @author tcanavan
 *
 */

public interface ObjectContainer {
    
    /**
     * Get All selected ids for the business object that is displated in the
     * grid
     * @return Long[]
     */ 
   
    public Long[] getAllSelected();
    
    /**
     * Get the selected id for the business object that is duplicated 
     * in the grid.
     * @return Long
     */

    public Long getSelected();
    
    /**
     * The container that the JTable is currently present in
     * This is used so the progress bar and any errormessages that
     * occur are displacyed with the correct parent
     * @return Container
     */

    public Container getTopLevelAncestor();
    
    /**
     * Get a complete list of OB/CB Ids's
     * @return Long[]
     */

    public Long[] getAll();
    
    /**
     * Get the Media associated with the grid displayed
     * Whether it is the database or local storage
     * @return Media
     */

    public Media getMedia();
    
    /**
     * Seleect all objects in the grid.
     */

    public void selectAllObjects();

}
