package org.eso.ohs.phase2.actions;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import javax.swing.AbstractAction;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.models.LimitedCharsModel;
import org.eso.ohs.core.gui.models.XdegModel;
import org.eso.ohs.core.gui.utilities.ImageUtils;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.gui.widgets.OutOfMemoryReport;
import org.eso.ohs.core.gui.widgets.RegexFormatter;
import org.eso.ohs.core.gui.widgets.SwingFileChooser;
import org.eso.ohs.core.gui.widgets.imageviewer.DisplayMode;
import org.eso.ohs.core.gui.widgets.imageviewer.FlipMode;
import org.eso.ohs.core.gui.widgets.imageviewer.ImageCanvas2D;
import org.eso.ohs.core.gui.widgets.imageviewer.PanZoom;
import org.eso.ohs.core.utilities.FileIOUtils;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.BusinessObject;
import org.eso.ohs.dfs.FindingChart;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.StorableObject;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.OHSPersistence;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.ObjectSelectionEvent;
import org.eso.ohs.persistence.ObjectSelectionListener;
import org.eso.ohs.persistence.ObjectSelector;
import org.eso.ohs.persistence.dbase.phase2.FindingChartsDBIO;

/**
 * @author tcanavan
 *
 * To change this generated comment e dit the template variable "typecomment":
 * Window>Preferences>Java>Templates. To enable and disable the creation of type
 * comments go to Window>Preferences>Java>Code Generation.
 */
public class FindingChartViewer
    extends JFrame
    implements ObjectSelectionListener, PropertyChangeListener, ObjectSelector {

    private static Logger stdlog_ =
        Logger.getLogger(FindingChartViewer.class);

    private JLabel statusStr = new JLabel();

    private String[] titles;

    private static FindingChartViewer jpegViewer;

    private int currentIndex;

    private JButton cancelBtn = new JButton("Cancel");

    private JButton printBtn = new JButton("Print");

    private JButton flipVBtn = new JButton();

    private JButton flipHBtn = new JButton();

    private JButton rotate90Btn = new JButton();

    private JButton rotate180Btn = new JButton();

    private JButton rotate270Btn = new JButton();

    private JButton rotateMinus90Btn = new JButton();

    private JButton rotateMinus180Btn = new JButton();

    private JButton rotateMinus270Btn = new JButton();

    private JButton rotateXDegrees = new JButton();

    private JButton lensBtn = new JButton();

    private JButton resetBtn = new JButton("Reset");

    private JButton clearLensBtn = new JButton("Clear Lense");

    private JButton prevBtn = new JButton("Previous");

    private JButton nextBtn = new JButton("Next");

    private JButton saveBtn = new JButton("Save");

    private JButton saveCommentsBtn = new JButton("Save Comments");

    private JButton printScaledBtn = new JButton("Print Scaled");

    private JLabel statusLabel = new JLabel();

    private JTextField degField;

    private ButtonGroup group = new ButtonGroup();
    //private JRadioButton sizeButton = new JRadioButton();

    private Media device_ = null;

    private boolean simple = false;

    private Mediator mediator = new Mediator();

    /** Object that is to be displayed in the ObjectView */
    private ObservationBlock ob_;

    private ImageCanvas2D comp = new ImageCanvas2D();

    private PanZoom zoom;

    private BufferedImage[] images;

    private HashMap transforms = new HashMap();

    private AffineTransform[] afs;

    private int[] modes;

    private long[] fcIds;

    private JMenu dispMode = new JMenu("Display Mode");

    private JLabel label = new JLabel("Finding Chart Comments");

    private JTextArea fcNotes = new JTextArea();

    /**  
       * Static reference to file chooser dialog
       */

    private static SwingFileChooser fileChooser_ = new SwingFileChooser();
    static {
        stdlog_.debug("Finding Chart " + AppConfig.getAppConfig().getFcDir());
        File f1 = new File(AppConfig.getAppConfig().getFcDir());
        fileChooser_.setCurrentDirectory(new File(f1.getParent()));
        fileChooser_.setSelectedFile(f1);
    }

    public static FindingChartViewer getInstance() {
        if (jpegViewer == null) {
            jpegViewer = new FindingChartViewer();
        }
        return jpegViewer;
    }

    /**
     * Constructor for JPEGV5,87iewer.
     * @throws HeadlessException
     */
    private FindingChartViewer() throws HeadlessException {
        super();
        getContentPane().setLayout(new BorderLayout());
        //south.setLayout(new BorderLayout());

        JPanel outerPanel = new JPanel(new BorderLayout());
        JPanel southpanel = new JPanel();
        southpanel.setLayout(new BoxLayout(southpanel, BoxLayout.X_AXIS));
        if (AppConfig.getAppConfig().getFCNotesEnabled()) {
            southpanel.add(label);
            JScrollPane pane = new JScrollPane(fcNotes);
            southpanel.add(pane);
            southpanel.add(saveCommentsBtn);
        }
        JPanel buttonPanel = createButtonPanel();
        addActions(buttonPanel);
        if (AppConfig.getAppConfig().getFCNotesEnabled()) {
            outerPanel.add(southpanel, BorderLayout.SOUTH);
        }
        outerPanel.add(buttonPanel, BorderLayout.NORTH);
        getContentPane().add(comp, BorderLayout.CENTER);
        getContentPane().add(outerPanel, BorderLayout.SOUTH);

        createViewModeMenu();
        group.add(new JRadioButton("Size To Fit"));
        group.add(new JRadioButton("Original Size"));
        if (AppConfig.getAppConfig().getFCNotesEnabled()) {
            fcNotes.setRows(2);
            fcNotes.setDocument(new LimitedCharsModel());
        }
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent ev) {
                setVisible(false);
                if (textChanged()) {
                    int result =
                        JOptionPane.showConfirmDialog(
                            comp,
                            "Finding Chart Comments Changed ?",
                            "Do you wish to save comments ?",
                            JOptionPane.YES_NO_OPTION);
                    if (result == JOptionPane.YES_OPTION) {
                        saveFindingChartComment();
                    }
                }
            }
        });

    }

    /**
     * @param buttonPanel
     */
    private void addActions(JPanel buttonPanel) {
        cancelBtn.setAction(new CancelActionListener(mediator));
        printBtn.addActionListener(new PrintActionListener());
        printScaledBtn.addActionListener(new PrintScaledAction());
        nextBtn.addActionListener(new NextActionListener(mediator));
        prevBtn.addActionListener(new PrevActionListener(mediator));
        buttonPanel.add(statusLabel);
        flipVBtn.setAction(new FlipVActionListener(mediator));
        flipHBtn.setAction(new FlipHActionListener(mediator));
        rotate90Btn.setAction(new Rotate90ActionListener(mediator));
        rotate180Btn.setAction(new Rotate180ActionListener(mediator));
        rotate270Btn.setAction(new Rotate270ActionListener(mediator));
        rotateMinus90Btn.setAction(new RotateMinus90ActionListener(mediator));
        rotateMinus180Btn.setAction(new RotateMinus180ActionListener(mediator));
        rotateMinus270Btn.setAction(new RotateMinus270ActionListener(mediator));
        rotateXDegrees.setAction(new RotateXDegrees(mediator));
        clearLensBtn.setAction(new ClearLensActionListener(mediator));
        resetBtn.setAction(new ResetActionListener(mediator));
        saveBtn.setAction(new SaveFCAction(Media.DBASE, this, "Save Jpg"));
        saveCommentsBtn.setAction(new SaveComments());
    }

    /**
     * @param buttonPanel
     */
    private JPanel createButtonPanel() {
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(2, 0));
        //south.setLayout(new BoxLayout(south, BoxLayout.X_AXIS));
        RegexFormatter formatter = null;
        formatter = new RegexFormatter("\\d*?([-]?\\d*)");
        degField = new JTextField();
        degField.setColumns(4);
        degField.setDocument(new XdegModel());
        buttonPanel.add(nextBtn);
        buttonPanel.add(prevBtn);
        buttonPanel.add(flipHBtn);
        buttonPanel.add(flipVBtn);
        buttonPanel.add(rotate90Btn);
        buttonPanel.add(rotate180Btn);
        buttonPanel.add(rotate270Btn);
        buttonPanel.add(rotateMinus90Btn);
        buttonPanel.add(rotateMinus180Btn);
        buttonPanel.add(rotateMinus270Btn);
        buttonPanel.add(rotateXDegrees);
        buttonPanel.add(degField);
        buttonPanel.add(resetBtn);
        buttonPanel.add(saveBtn);
        buttonPanel.add(printBtn);
        buttonPanel.add(printScaledBtn);
        buttonPanel.add(cancelBtn);
        buttonPanel.add(Box.createGlue());
        return buttonPanel;
    }

    public void createViewModeMenu() {
        JMenuBar mb = new JMenuBar();
        dispMode = new JMenu("Display Mode");
        JMenuItem orig = new JMenuItem("Original Size");
        JMenuItem scaled = new JMenuItem("Scaled");
        orig.addActionListener(new DisplayModeAdapter(DisplayMode.ORIG_SIZE));
        scaled.addActionListener(new DisplayModeAdapter(DisplayMode.SCALED));
        dispMode.add(orig);
        dispMode.add(scaled);
        String menuName = "File";
        JMenu menu = new JMenu(menuName);
        JMenuItem close = new JMenuItem("Close");
        close.setAccelerator(
            KeyStroke.getKeyStroke(KeyEvent.VK_W, InputEvent.CTRL_MASK, false));
        close.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
                if (AppConfig.getAppConfig().getFCNotesEnabled()) {
                    if (textChanged()) {
                        int result =
                            JOptionPane.showConfirmDialog(
                                comp,
                                "Finding Chart Comments Changed ?",
                                "Do you wish to save comments ?",
                                JOptionPane.YES_NO_OPTION);
                        if (result == JOptionPane.YES_OPTION) {
                            saveFindingChartComment();
                        }
                    }
                }

            }
        });
        menu.add(close);
        mb.add(menu);
        mb.add(dispMode);
        setJMenuBar(mb);
    }

    public void displayFindingChartImage(BufferedImage image) {
        if (zoom != null) {
            zoom.setPanZoomOn(false);
        }
        if (comp.getDisplayedImage() != null)
            comp.clearImageCanvas();
        comp.setBufferedImage(image);
        comp.setDisplayMode(modes[currentIndex]);
        if (afs[currentIndex] == null) {
            afs[currentIndex] = comp.getTransform();
        } else {
            comp.setTransform(afs[currentIndex]);
            comp.applyTransform(afs[currentIndex]);
        }
        zoom = new PanZoom(comp);
        statusLabel.setText(
            (currentIndex + 1) + " of " + ob_.getFindingCharts().length);
        makeTitle();
    }

    private void setBtnEnabled(boolean enabled) {
        printBtn.setEnabled(enabled);
        nextBtn.setEnabled(enabled);
        prevBtn.setEnabled(enabled);
        flipVBtn.setEnabled(enabled);
        flipHBtn.setEnabled(enabled);
        rotate90Btn.setEnabled(enabled);
        rotate180Btn.setEnabled(enabled);
        rotate270Btn.setEnabled(enabled);
        rotateMinus90Btn.setEnabled(enabled);
        rotateMinus180Btn.setEnabled(enabled);
        rotateMinus270Btn.setEnabled(enabled);
        rotateXDegrees.setEnabled(enabled);
        clearLensBtn.setEnabled(enabled);
        resetBtn.setEnabled(enabled);
        printScaledBtn.setEnabled(enabled);
        saveBtn.setEnabled(enabled);
        saveCommentsBtn.setEnabled(enabled);
        fcNotes.setEnabled(enabled);

    }

    public void init(Media media, ObservationBlock ob)
        throws IOException, ObjectNotFoundException, ObjectIOException {
        device_ = media;
        currentIndex = 0;
        setDisplayedObject(ob);
        FindingChart[] fcCharts = ob.getFindingCharts();
        for (int i = 0; i < fcCharts.length; i++) {
            fcCharts[i].setObsRun(ob.getObsRun());
        }
        System.gc();
        if (fcCharts.length == 0) {
            if (comp.getDisplayedImage() != null)
                comp.clearImageCanvas();
            fcNotes.setText("");
            setBtnEnabled(false);
            dispMode.setEnabled(false);
            statusLabel.setText("");
            degField.setText("");
            if (zoom != null) {
                zoom.setPanZoomOn(false);
            }
            makeTitle();
            return;
        } else {
            setBtnEnabled(true);
            dispMode.setEnabled(true);
        }
        if (images != null) {
            for (int i = 0; i < images.length; i++) {
                images[i] = null;
            }
        }
        images = new BufferedImage[fcCharts.length];
        afs = new AffineTransform[fcCharts.length];
        modes = new int[fcCharts.length];
        fcIds = new long[fcCharts.length];
        OHSPersistence persistence =
            (OHSPersistence) OHSPersistence.getObjectManager();
        FindingChart[] fcs = null;
        if (device_.equals(Media.DBASE))
            fcs = persistence.populateFindingCharts(Media.DBASE, ob.getId());
        if (transforms.containsKey(new Long(ob.getId()))) {
            TransformElement elem =
                (TransformElement) transforms.get(new Long(ob.getId()));
            afs = elem.getAtfx();
            long[] fcIds = elem.getFcIds();
            for (int i = 0; i < fcs.length; i++) {
                for (int j = 0; j < fcIds.length; j++) {
                    if (fcIds[j] == fcs[i].getId()) {
                        afs[i] = elem.getTransformFromFCId(fcIds[i]);
                        modes[i] = elem.getModeFromFCId(fcIds[i]);
                    }
                }
            }
        } else {
            for (int i = 0; i < modes.length; i++) {
                if (AppConfig.getAppConfig().isFCScaled()) {
                    modes[i] = DisplayMode.SCALED;
                } else {
                    modes[i] = DisplayMode.ORIG_SIZE;
                }
            }
        }
        for (int i = 0; i < images.length; i++) {
            ByteArrayInputStream stream =
                new ByteArrayInputStream(fcs[i].getFcData());
            Image img =
                Toolkit.getDefaultToolkit().createImage(fcs[i].getFcData());
            fcIds[i] = fcs[i].getId();
            MediaTracker mediaTracker = new MediaTracker(this);
            mediaTracker.addImage(img, 0);
            try {
                mediaTracker.waitForID(0);
            } catch (InterruptedException ie) {
                // TODO put Error Message in.
                //  System.exit(1);
            }
            images[i] =
                ImageCanvas2D.convertToBufferedImage(
                    img,
                    img.getWidth(null),
                    img.getHeight(null),
                    ImageCanvas2D.TYPE_AWT_IMAGE);
        }
        try {
            comp.setDisplayMode(modes[0]);
            displayFindingChartImage(images[0]);
            stdlog_.debug("FC NOTES " + fcs[0].getFcNotes());
            String text = fcs[0].getFcNotes();
            stdlog_.debug("FC NOTES 0" + text);
            //text = "New Text";
            fcNotes.setText(text);
            stdlog_.debug("FC NOTES 1" + fcNotes.getText());
            setPrevNextButton();
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            int maxWidth = ((screenSize.width / 10) * 9);
            int maxHeight = ((screenSize.height / 8) * 7);
            Dimension d = new Dimension(maxWidth, maxHeight);
            setSize(d);
            setVisible(true);
        } catch (OutOfMemoryError e) {
            OutOfMemoryReport.showMessage();
        }
        //pack();

    }

    public void makeTitle() {
        FindingChart[] fcCharts = ob_.getFindingCharts();
        if (fcCharts.length == 0)
            setTitle(
                "OB Name " + ob_.getName() + " no finding charts attached");
        else {
            setTitle(
                    ob_.getObsRun().getName() 
                    + " OB Name="
                    + ob_.getName()
                    + " FindingChart Name="
                    + fcCharts[currentIndex].getFcName()
                    + " Mode="
                    + getDisplayModeString(modes[currentIndex]));
        }

    }

    public String getDisplayModeString(int mode) {
        switch (mode) {
            case DisplayMode.ORIG_SIZE :
                return "Original size";
            case DisplayMode.TO_FIT :
                return "Fit the viewport";
            case DisplayMode.SCALED :
                return "Scaled to fit the viewport";
            default :
                return null;
        }
    }

    private class NextActionListener extends AbstractAction {

        private Mediator mediator;

        public NextActionListener(Mediator mediator) {
            super("Next");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class PrevActionListener extends AbstractAction {

        private Mediator mediator;

        public PrevActionListener(Mediator mediator) {
            super("Previous");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class LensActionListener extends AbstractAction {

        private Mediator mediator;

        public LensActionListener(Mediator mediator) {
            super("Lens");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class ClearLensActionListener extends AbstractAction {

        private Mediator mediator;

        public ClearLensActionListener(Mediator mediator) {
            super("Clear Lens");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class CancelActionListener extends AbstractAction {

        private Mediator mediator;

        public CancelActionListener(Mediator mediator) {
            super("Cancel");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class FlipHActionListener extends AbstractAction {

        private Mediator mediator;

        public FlipHActionListener(Mediator mediator) {
            super("Flip Horizontal");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }

    }

    private class FlipVActionListener extends AbstractAction {

        private Mediator mediator;

        public FlipVActionListener(Mediator mediator) {
            super("Flip Vertical");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class ResetActionListener extends AbstractAction {
        private Mediator mediator;

        public ResetActionListener(Mediator mediator) {
            super("Reset");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class Rotate90ActionListener extends AbstractAction {
        private Mediator mediator;

        public Rotate90ActionListener(Mediator mediator) {
            super("+90");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class Rotate180ActionListener extends AbstractAction {
        private Mediator mediator;

        public Rotate180ActionListener(Mediator mediator) {
            super("+180");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class Rotate270ActionListener extends AbstractAction {
        private Mediator mediator;

        public Rotate270ActionListener(Mediator mediator) {
            super("+270");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class RotateMinus90ActionListener extends AbstractAction {
        private Mediator mediator;

        public RotateMinus90ActionListener(Mediator mediator) {
            super("-90");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class RotateMinus180ActionListener extends AbstractAction {
        private Mediator mediator;

        public RotateMinus180ActionListener(Mediator mediator) {
            super("-180");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class RotateMinus270ActionListener extends AbstractAction {
        private Mediator mediator;

        public RotateMinus270ActionListener(Mediator mediator) {
            super("-270");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class RotateXDegrees extends AbstractAction {
        private Mediator mediator;

        public RotateXDegrees(Mediator mediator) {
            super("XDeg");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    private class ZoomAction extends AbstractAction {
        private Mediator mediator;

        public ZoomAction(Mediator mediator) {
            super("Zoom");
            this.mediator = mediator;
        }

        public void actionPerformed(ActionEvent e) {
            mediator.forwardActionEvent(e);
        }
    }

    public void rotate(double ang) {
        float angleInRad = (float) (ang * (Math.PI / 180.0F));

        Dimension dim = comp.getImageSize();
        int wid = dim.width;
        int ht = dim.height;
        AffineTransform atx = comp.getTransform();
        atx.rotate(angleInRad, wid / 2, ht / 2);
        comp.applyTransform(atx);
    }

    private class PrintActionListener extends AbstractAction {

        public PrintActionListener() {
            super("Print");
        }

        public void actionPerformed(ActionEvent e) {
            comp.printContents();
        }

    }

    private void setPrevNextButton() {
        FindingChart[] fcs = ob_.getFindingCharts();
        if (fcs.length == 1) {
            nextBtn.setEnabled(false);
            prevBtn.setEnabled(false);
        } else if (currentIndex == 0) {
            prevBtn.setEnabled(false);
            nextBtn.setEnabled(true);
        } else if (currentIndex == fcs.length - 1) {
            prevBtn.setEnabled(true);
            nextBtn.setEnabled(false);
        } else {
            prevBtn.setEnabled(true);
            nextBtn.setEnabled(true);
        }
    }

    /**
     * This class mediates between the various compoments in the widget.
     * All Events from the next and previous button are passed to the
     * Mediator class. It then updates the gui appropriately.
     * @author tcanavan
     *
     * To change this generated comment edit the template variable "typecomment":
     * Window>Preferences>Java>Templates.
     * To enable and disable the creation of type comments go to
     * Window>Preferences>Java>Code Generation.
     */

    private class Mediator {

        public void forwardActionEvent(ActionEvent ev) {
            if (ev.getActionCommand().equals("Cancel")) {
                processCancelEvent();
            }
            if (ev.getActionCommand().equals("+90")) {
                processRotateEvent(90);
            }

            if (ev.getActionCommand().equals("+180")) {
                processRotateEvent(180);
            }
            if (ev.getActionCommand().equals("+270")) {
                processRotateEvent(270);
            }
            if (ev.getActionCommand().equals("-90")) {
                processRotateEvent(-90);
            }

            if (ev.getActionCommand().equals("-180")) {
                processRotateEvent(-180);
            }
            if (ev.getActionCommand().equals("-270")) {
                processRotateEvent(-270);
            }
            if (ev.getActionCommand().equals("Flip Vertical")) {
                processFlipVerticalEvent();
            }

            if (ev.getActionCommand().equals("Flip Horizontal")) {
                processFlipHorizontalEvent();
            }

            if (ev.getActionCommand().equals("XDeg")) {
                String text = degField.getText();
                if (text == null || text.length() == 0)
                    return;
                int degrees = 0;
                try {
                    degrees = new Integer(degField.getText()).intValue();
                } catch (NumberFormatException e) {
                    //
                }
                if (degrees == 0 || degrees > 360 || degrees < -360) {
                    JOptionPane.showMessageDialog(
                        comp,
                        new Object[] { "Value must be between -360 and 360" },
                        "Value out of range",
                        JOptionPane.ERROR_MESSAGE);
                    return;

                }
                processRotateEvent(degrees);

            }

            if (ev.getActionCommand().equals("Reset")) {
                processResetEvent();
            }

            if (ev.getActionCommand().equals("Next")) {
                processNextEvent();
            }

            if (ev.getActionCommand().equals("Previous")) {
                processPreviousEvent();
            }
        }

        private void processNextEvent() {
            FindingChart[] fcs = ob_.getFindingCharts();
            if (textChanged()) {
                if (AppConfig.getAppConfig().getFCNotesEnabled()) {
                    int result =
                        JOptionPane.showConfirmDialog(
                            comp,
                            "Finding Chart Comments Changed ?",
                            "Do you wish to save comments ?",
                            JOptionPane.YES_NO_OPTION);
                    if (result == JOptionPane.YES_OPTION) {
                        saveFindingChartComment();
                    }
                }
            }
            if (currentIndex < fcs.length)
                currentIndex++;
            else {
                return;
            }
            displayFindingChartImage(images[currentIndex]);
            if (fcs[currentIndex].getFcNotes() != null)
                fcNotes.setText(fcs[currentIndex].getFcNotes().trim());
            else {
                fcNotes.setText("");
            }

            setPrevNextButton();
        }

        private void processPreviousEvent() {
            FindingChart[] fcs = ob_.getFindingCharts();
            if (AppConfig.getAppConfig().getFCNotesEnabled()) {
                if (textChanged()) {
                    int result =
                        JOptionPane.showConfirmDialog(
                            comp,
                            "Finding Chart Comments Changed ?",
                            "Do you wish to save comments ?",
                            JOptionPane.YES_NO_OPTION);
                    if (result == JOptionPane.YES_OPTION) {
                        saveFindingChartComment();
                    }
                }
            }
            if (currentIndex > 0)
                currentIndex--;
            else {
                return;
            }
            displayFindingChartImage(images[currentIndex]);
            if (fcs[currentIndex].getFcNotes() != null)
                fcNotes.setText(fcs[currentIndex].getFcNotes().trim());
            else {
                fcNotes.setText("");
            }
            setPrevNextButton();
        }

        /**
         * Method processLensEvent.
         */
        /*private void processLensEvent() {            
            if(lensFrame != null) { lensFrame.dispose();}
                lensFrame = new JFrame();
                lensFrame.addWindowListener(
                   new WindowAdapter(){
                      public void windowClosing(WindowEvent w){
                         zoom.setPanZoomOn(true);
                         lensPanel.setLensOn(false);
                      }
                   }
                );
                lensPanel = new LensPanel(imgCanvasList[tabPane.getSelectedIndex()]);
                lensFrame.getContentPane().add(lensPanel);
                lensFrame.pack();
             //}
             imgCanvasList[tabPane.getSelectedIndex()].paintImage();
             zoom.setPanZoomOn(false);
             lensFrame.show();
             lensPanel.setLensOn(true);
        
            
        }*/

        public AffineTransform createFlipTransform(
            int mode,
            int imageWid,
            int imageHt) {
            AffineTransform at = new AffineTransform();
            switch (mode) {
                case FlipMode.NORMAL :
                    break;
                case FlipMode.TOP_BOTTOM :
                    at =
                        new AffineTransform(
                            new double[] { 1.0, 0.0, 0.0, -1.0 });
                    at.translate(0.0, -imageHt);
                    break;
                case FlipMode.LEFT_RIGHT :
                    at =
                        new AffineTransform(
                            new double[] { -1.0, 0.0, 0.0, 1.0 });
                    at.translate(-imageWid, 0.0);
                    break;
                case FlipMode.TOP_BOTTOM_LEFT_RIGHT :
                    at =
                        new AffineTransform(
                            new double[] { -1.0, 0.0, 0.0, -1.0 });
                    at.translate(-imageWid, -imageHt);
                    break;
                default :
                    }
            return at;
        }

        public void flip(int mode) {
            Dimension dim = comp.getImageSize();
            int wid = dim.width;
            int ht = dim.height;
            AffineTransform flipTx = createFlipTransform(mode, wid, ht);
            AffineTransform atx = comp.getTransform();
            atx.concatenate(flipTx);
            comp.applyTransform(atx);
        }

        private void processFlipVerticalEvent() {
            flip(FlipMode.TOP_BOTTOM);
        }

        private void processRotateEvent(int degrees) {
            rotate(degrees);
        }

        private void processFlipHorizontalEvent() {
            flip(FlipMode.LEFT_RIGHT);

        }

        private void processResetEvent() {
            comp.reset();
            afs[currentIndex] = null;
        }

        private void processCancelEvent() {
            setVisible(false);
            //dispose();
        }

    }

    /**
         * Sets the object to be displayed by the ObjectView within this
         * DocHolder.  However, setDisplayedObject() may not immediately be
         * called on the ObjectView, if it is not currently visible to the user.
         * 
         * @param   vc          Containing ViewContainer for this DocHolder
         * @param   isVisible   True if window is now visible, false otherwise
         */
    public void setDisplayedObject(ObservationBlock obj) {
        if (ob_ != null) {
            ob_.removePropertyChangeListener(this);
        }
        ob_ = obj;
        if (ob_ != null) {
            ob_.addPropertyChangeListener(this);
        }
    }

    /**
     * @see org.eso.ohs.persistence.ObjectSelectionListener#objectSelected(org.eso.ohs.apps.ObjectSelectionEvent)
     */
    public void objectSelected(ObjectSelectionEvent ev) {
        if (!isVisible())
            return;

        if (simple
            && ev.getMedia().equals(Media.DBASE)
            && !Config.getCfg().isInOperationsMode()) {
            return;
        }
        ObjectManager objMgr = ObjectManager.getObjectManager();
        if (ev.getObjectId() == ObjectSelectionEvent.NO_OBJECT) {
            reinit();
            return;
        }
        try {
            StorableObject bo =
                objMgr.getBusObj(
                    ev.getMedia(),
                    ev.getObjectId(),
                    ev.getObjectClass());

            if (ob_ != null) {
                if (ob_.getId() != bo.getId()) {
                    TransformElement transformElement =
                        new TransformElement(ob_.getId(), afs, modes, fcIds);
                    transforms.put(new Long(ob_.getId()), transformElement);
                }
            }
            if (bo instanceof ObservationBlock) {
                setDisplayedObject((ObservationBlock) bo);
                FindingChart[] fcs =
                    ((ObservationBlock) ob_).getFindingCharts();

                init(ev.getMedia(), ob_);
            } else {
                reinit();
            }

        } catch (ObjectNotFoundException e) {
            ErrorMessages.announceIOError(comp, e);

        } catch (ObjectIOException e) {
            ErrorMessages.announceIOError(comp, e);

        } catch (IOException e) {
            ErrorMessages.announceIOError(comp, e);
        }

    }

    public void reinit() {
        repaint();
    }

    /**
     * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
     */
    public void propertyChange(PropertyChangeEvent ev) {
        if (Config.getCfg().isInOperationsMode()) {
            return;
        }
        makeTitle();

        if (ev.getPropertyName() != null
            && ev.getPropertyName().equals("FindingCharts")) {
            try {
                init(device_, ob_);
            } catch (IOException e) {
                ErrorMessages.announceIOError(comp, e);
            } catch (ObjectNotFoundException e) {
                ErrorMessages.announceNoObject(comp, e);
            } catch (ObjectIOException e) {
                ErrorMessages.announceIOError(comp, e);
            }

        }

    }

    private class DisplayModeAdapter implements ActionListener {
        int dispmode;
        public DisplayModeAdapter(int mode) {
            dispmode = mode;
        }
        public void actionPerformed(ActionEvent e) {
            //comp.setDisplayMode(dispmode);
            afs[currentIndex] = null;
            modes[currentIndex] = dispmode;
            displayFindingChartImage(images[currentIndex]);
            makeTitle();
        }
    }

    private class TransformElement {

        /**
         * OB ID to be cached.
         * 
         */

        private long obId;

        /**
         * The finding chart list id from the database 
         */

        private long[] fcIds = {
        };

        /**
         * The transformation that were 
         *  last applied to this finding chart for a given OB
         */

        private AffineTransform[] atfx = {
        };

        /**
         * The modes that were set for the finding chart widget 
         */

        private int[] displayMode;

        public TransformElement(
            long obId,
            AffineTransform[] atfx,
            int[] displayMode,
            long[] fcIds) {
            this.fcIds = fcIds;
            this.atfx = atfx;
            this.displayMode = displayMode;
            this.obId = obId;

        }

        /**
         * The transformation 
         * @return AffineTransform[]
         */
        public AffineTransform[] getAtfx() {
            return atfx;
        }

        /**
         * Returns the displayMode.
         * @return int[]
         */
        public int[] getDisplayMode() {
            return displayMode;
        }

        /**
         * Returns the fcId.
         * @return long[]
         */
        public long[] getFcIds() {
            return fcIds;
        }

        /**
         * Returns the obId.
         * @return int
         */
        public long getObId() {
            return obId;
        }

        /**
         * Sets the atfx.
         * @param atfx The atfx to set
         */
        public void setAtfx(AffineTransform[] atfx) {
            this.atfx = atfx;
        }

        /**
         * Sets the displayMode.
         * @param displayMode The displayMode to set
         */
        public void setDisplayMode(int[] displayMode) {
            this.displayMode = displayMode;
        }

        /**
         * Sets the fcId.
         * @param fcId The fcId to set
         */
        public void setFcIds(long[] fcIds) {
            this.fcIds = fcIds;
        }

        /**
         * Sets the obId.
         * @param obId The obId to set
         */
        public void setObId(int obId) {
            this.obId = obId;
        }

        public AffineTransform getTransformFromFCId(long fcId) {
            for (int i = 0; i < fcIds.length; i++) {
                if (fcId == fcIds[i]) {
                    return atfx[i];
                }
            }
            return null;
        }

        public int getModeFromFCId(long fcId) {
            for (int i = 0; i < fcIds.length; i++) {
                if (fcId == fcIds[i]) {
                    return displayMode[i];
                }
            }
            return -1;
        }

    }

    /**
     * The text changed in the textArea
     * @return boolean
     */

    private boolean textChanged() {
        String text = fcNotes.getText().trim();
        FindingChart[] fcs = ob_.getFindingCharts();
        String text2 = fcs[currentIndex].getFcNotes();
        stdlog_.debug("Curent Index " + currentIndex);
        stdlog_.debug("Name = " + fcs[currentIndex].getFcName());
        stdlog_.debug("Text 2 = " + text2);
        stdlog_.debug("Text From GUI = " + text);                
        if(text2==null)
            text2="";
        if (text.equals(text2.trim())) {
            return false;
        }
        return true;
    }

    private class SaveComments extends AbstractAction {

        public SaveComments() {
            super("Save");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
            // TODO Auto-generated method stub
            saveCommentsBtn.setEnabled(false);
            saveFindingChartComment();
            saveCommentsBtn.setEnabled(true);
        }

    }

    private void saveFindingChartComment() {
        FindingChart[] fcs = ob_.getFindingCharts();
        long checkSum = fcs[currentIndex].getCheckSum();
        stdlog_.debug("Finding Chart Id" + checkSum);
        try {
            FindingChartsDBIO.updateFindingChartNotes(
                checkSum,
                fcNotes.getText());
            fcs[currentIndex].setFcNotes(fcNotes.getText());
        } catch (ObjectIOException e) {
            ErrorMessages.announceIOError(comp, e);
        }
    }

    private class SaveAction extends AbstractAction {

        public SaveAction() {
            super("Save");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
            // TODO Auto-generated method stub
            fileChooser_.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            fileChooser_.setCurrentDirectory(
                fileChooser_.getCurrentDirectory());
            int response =
                fileChooser_.showDialog(
                    null,
                    "Select Finding Chart Directory ");
            if (response == JOptionPane.CLOSED_OPTION
                || response == JOptionPane.CANCEL_OPTION)
                return;
            if (response == JFileChooser.APPROVE_OPTION) {
                File f = fileChooser_.getSelectedFile();
                if (!f.canWrite()) {
                    JOptionPane.showMessageDialog(
                        null,
                        new Object[] { "No write permissions to save Finding Charts to this directory" },
                        "No write permisssions",
                        JOptionPane.ERROR_MESSAGE);
                } else {
                    if (ob_ != null) {
                        FindingChart[] fcs = ob_.getFindingCharts();
                        for (int i = 0; i < fcs.length; i++) {
                            File outFile =
                                new File(
                                    f.getAbsolutePath()
                                        + File.separator
                                        + fcs[i].getFcName()
                                        + ".jpg");
                            try {
                                FileIOUtils.writeBinaryFile(
                                    fcs[i].getFcData(),
                                    outFile);
                            } catch (IOException e) {
                                // TODO Auto-generated catch block
                                ErrorMessages.announceIOError(comp, e);
                            }
                        }
                    }
                }
            }

        }

    }
    
    
    private class PrintScaledAction extends AbstractAction {

        public PrintScaledAction() {
            super("Print Scaled");
        }

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent arg0) {
            // TODO Auto-generated method stub
            JPEGPanel panel = new JPEGPanel();
            OHSPersistence persistence =
                (OHSPersistence) OHSPersistence.getObjectManager();
            FindingChart[] fcs=null;
            try {
                fcs = persistence.populateFindingCharts(Media.DBASE, ob_.getId());
            } catch (ObjectIOException e) {
                ErrorMessages.announceIOError(comp,e);
                return;
            }
            PrinterJob prnJob = PrinterJob.getPrinterJob();
            if (!prnJob.printDialog())
                 return;
            ImageIcon imIcon = new ImageIcon(fcs[currentIndex].getFcData());
            BufferedImage img =
                ImageUtils.convertToBufferedImage(
                    imIcon.getImage(),
                    imIcon.getIconWidth(),
                    imIcon.getIconHeight(),
                    1);
            panel.setBufferedImage(img);
            prnJob.setPrintable(panel);
            try {
                prnJob.print();
            } catch (PrinterException e) {
                String [] text = new String[1];
                text[0] = "Printer Error";
                ErrorMessages.announceError(comp,text,e);
            }

        }

    }
    
    
    public Dimension getDim(
        int pageWidth,
        int pageHeight,
        int imageWidth,
        int imageHeight) {
        double magX = (double) imageWidth / (double) pageWidth;
        double magY = (double) imageHeight / (double) pageHeight;
        int dwidth = 0, dheight = 0;
        double mag = Math.max(magX, magY);
        Double db = new Double(imageWidth / mag);
        dwidth = db.intValue();
        db = new Double(imageHeight / mag);
        dheight = db.intValue();
        return new Dimension(dwidth, dheight);
    }
    
    
    private class JPEGPanel extends JPanel implements Printable {
        private BufferedImage bufferedImage;

        public int print(Graphics pg, PageFormat pageFormat, int pageIndex) {
            if (pageIndex >= 1)
                return NO_SUCH_PAGE;
            pg.translate(
                (int) pageFormat.getImageableX(),
                (int) pageFormat.getImageableY());
            int wPage = (int) pageFormat.getImageableWidth();
            int hPage = (int) pageFormat.getImageableHeight();
            if (bufferedImage == null)
                return NO_SUCH_PAGE;

            int w = bufferedImage.getWidth();
            int h = bufferedImage.getHeight();

            Dimension d = null;
            if (h < hPage && w < wPage) {
                d = new Dimension(w,h);
            } else {
                d = getDim(wPage, hPage, w, h);                    
            }

            JLabel label = new JLabel(ob_.getObsRun().getName());
            FontMetrics fm = pg.getFontMetrics();
            int y=fm.getAscent();
            pg.drawString(label.getText(),0,y);
            pg.drawImage(
                bufferedImage,
                0,
                y+5,
                (int) d.getWidth(),
                (int) d.getHeight(),
                this);
            System.gc();
            return PAGE_EXISTS;
        }

        /**
         * Returns the bufferedImage.
         * @return BufferedImage
         */
        public BufferedImage getBufferedImage() {
            return bufferedImage;
        }

        /**
         * Sets the bufferedImage.
         * @param bufferedImage The bufferedImage to set
         */
        public void setBufferedImage(BufferedImage bufferedImage) {
            this.bufferedImage = bufferedImage;
        }

    }



    /* (non-Javadoc)
     * @see org.eso.ohs.apps.ObjectSelector#getDisplayedObject()
     */
    public BusinessObject getDisplayedObject() {
        // TODO Auto-generated method stub
        return ob_;
    }

}
