package org.eso.ohs.phase2.apps.masktracker;



/**
 * Interface to the database for Mask updates that cannot go
 * through the ObjectManager.
 * 
 * <p>
 * $Id: DbaseMaskReports.java,v 1.11 2003/09/03 15:26:53 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 * @author Tim Canavan
 */
public class DbaseMaskReports {
   

    public static class MaskInfo {

        /**
         * OB id associated with a given mask
         */

        private long obId_;


        /**
         * Naid value associated with mask
         * 
         */
        private String naid_;

        /**
         * The mask id which is used for tracking purposes
         *
         */

        private String maskId_;

        /** Parameter value */
        private String paramValue_;


	/**
          * Set Naid from Paf File
          */
        public void setNaid(String naid) {
            naid_ = naid;
        }

        /** Set mask id*/

        public void setMaskId(String maskId) {
            maskId_ = maskId;
        }

        /**  
         * Set Parameter value
         */
        public void setParamValue(String paramValue) {
            paramValue_ = paramValue;
        }


        /** 
         * Set OB id
         */
        public void setObId(long obId) {
            obId_ = obId;
        }

        /** 
         * Get the mask id
         * Id of mask for Mask tracking
         */

        public String getMaskId() {
            return maskId_;
        }


        /** 
         * Get the naid
         * Mask Naid
         */
        public String getNaid() {
            return naid_;
        }

        /** Get the Parameter value
         *  @return adm value
         */
        public String getParamValue() {
            return paramValue_;
        }
 
        /** */
        public String toString() {
            StringBuffer buf = new StringBuffer();
            buf.append("Ob id " + obId_);
            buf.append(" Mask Id " + maskId_);
            buf.append(" Mask Naid " + naid_);
            buf.append(" Mask Parameter Value " + paramValue_);
            return buf.toString();
        }
     
    }
}









