/*
 * @(#)GridBagAdder.java     $Revision: 1.3 $    $Date: 2003/07/03 08:49:49 $
 *
 * Copyright (C) 2000 European Southern Observatory 
 * License:  GNU General Public License version 2 or later
 *
 */

package org.eso.ohs.phase2.apps.ot.gui;


import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;



/** Class used to add component into a GrdiBagLayout 
 *
 *  @version $Revision: 1.3 $
 *  @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */

class GridBagAdder {
        // OK to reuse this as we overwrite all elements every time
        // Note that this is not threadsafe however!
        static GridBagConstraints cons = new GridBagConstraints();

        /** add a component to a container */
        public static void add(Container cont, Component comp, int x, int y,
                               int width, int height, int weightx,
                               int weighty, int fill, int anchor) {
            cons.gridx = x;
            cons.gridy = y;
            cons.gridwidth = width;
            cons.gridheight = height;
            cons.weightx = weightx;
            cons.weighty = weighty;
            cons.fill = fill;
            cons.anchor = anchor;
            cont.add(comp, cons);
        }
    }
