package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;

import com.jeta.forms.components.image.ImageComponent;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class VisibilityConstraintFilterView extends OHSWizardPage {
    
    JRadioButton radioButtonInactiveTimeInterval = new JRadioButton();
    OHSButtonGroup buttongroupTimeInt = new OHSButtonGroup(OrangWizard.BUTTONGROUP_TIME_INT);
    JRadioButton radioButtonActiveTimeInterval = new JRadioButton();
    JRadioButton radioButtonInactiveSidTimeInt = new JRadioButton();
    JRadioButton radioButtonActiveSidTimeInt = new JRadioButton();
      OHSButtonGroup buttongroupSidTimeInt = new OHSButtonGroup(OrangWizard.BUTTONGROUP_SID_TIME);
    JLabel labelTitle = new JLabel();

    JLabel labelPageTitle = new JLabel();

    JLabel labelFLI = new JLabel();

    JLabel labelMoonDistance = new JLabel();

    JLabel labelAirmass = new JLabel();

    JRadioButton radioButtonInactiveFLI = new JRadioButton();

    OHSButtonGroup buttongroupFLI = new OHSButtonGroup(OrangWizard.BUTTONGROUP_FLI);

    JRadioButton radioButtonActiveFLI = new JRadioButton();

    JSpinner spinnerToleranceFLI = new JSpinner();

    JLabel labelToleranceFLI = new JLabel();

    JRadioButton radioButtonInactiveMoonDistance = new JRadioButton();

    OHSButtonGroup buttongroupMoonD = new OHSButtonGroup(OrangWizard.BUTTONGROUP_MOON_D);

    JRadioButton radioButtonActiveMoonDistance = new JRadioButton();

    JSpinner spinnerToleranceMoonDistance = new JSpinner();

    JLabel labelToleranceMoonDistance = new JLabel();

    JSpinner spinnerToleranceAirmass = new JSpinner();

    JLabel labelToleranceAirmass = new JLabel();

    JLabel labelSunAngle = new JLabel();

    JRadioButton radioButtonInactiveSunAngle = new JRadioButton();

    OHSButtonGroup buttongroupSun = new OHSButtonGroup(OrangWizard.BUTTONGROUP_SUN);

    JRadioButton radioButtonActiveSunAngle = new JRadioButton();

    JSpinner spinnerToleranceSunAngle = new JSpinner();

    JLabel labelToleranceSunAngle = new JLabel();

    JLabel labelMoonAngle = new JLabel();

    JRadioButton radioButtonInactiveMoonAngle = new JRadioButton();

    OHSButtonGroup buttongroupMoonA = new OHSButtonGroup(OrangWizard.BUTTONGROUP_MOON_A);

    JRadioButton radioButtonActiveMoonAngle = new JRadioButton();

    JSpinner spinnerToleranceMoonAngle = new JSpinner();

    JLabel labelToleranceMoonAngle = new JLabel();
    
    JLabel labelInfo = new JLabel();
    ImageComponent orange = new ImageComponent();
    JRadioButton radioButtonInactiveZenith = new JRadioButton();
    ButtonGroup buttongroupZenith = new OHSButtonGroup(OrangWizard.BUTTONGROUP_ZENITH);
    JRadioButton radioButtonActiveZenith = new JRadioButton();
    
    private OrangWidgetsData dataWidgets; 

    /**
     * Default constructor
     * @param defaultData 
     */
    public VisibilityConstraintFilterView(OHSWizard controller, OrangWidgetsData defaultData) {
        super(controller);
        dataWidgets = defaultData;
        initializePanel();
    }

    /**
     * Adds fill components to empty cells in the first row and first column of
     * the grid. This ensures that the grid spacing will be the same as shown in
     * the designer.
     * 
     * @param cols
     *            an array of column indices in the first row where fill
     *            components should be added.
     * @param rows
     *            an array of row indices in the first column where fill
     *            components should be added.
     */
    void addFillComponents(Container panel, int[] cols, int[] rows) {
        Dimension filler = new Dimension(10, 10);

        boolean filled_cell_11 = false;
        CellConstraints cc = new CellConstraints();
        if (cols.length > 0 && rows.length > 0) {
            if (cols[0] == 1 && rows[0] == 1) {
                /** add a rigid area */
                panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                filled_cell_11 = true;
            }
        }

        for (int index = 0; index < cols.length; index++) {
            if (cols[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
        }

        for (int index = 0; index < rows.length; index++) {
            if (rows[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
        }

    }

    
    
    public JPanel createPanel()
    {
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,LEFT:DEFAULT:NONE,LEFT:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:46PX:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0)","CENTER:PREF:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);

       labelPageTitle.setFont(new Font("sansserif",Font.ITALIC,11));
       labelPageTitle.setName("labelPageTitle");
       labelPageTitle.setText("Step 3: tune visibility computation constraints");
       jpanel1.add(labelPageTitle,cc.xywh(2,3,6,1));

       labelFLI.setName("labelFLI");
       labelFLI.setText("FLI");
       jpanel1.add(labelFLI,cc.xy(2,8));

       radioButtonInactiveFLI.setActionCommand("Inactive");
       radioButtonInactiveFLI.setName("radioButtonInactiveFLI");
       radioButtonInactiveFLI.setText("Inactive");
       buttongroupFLI.add(radioButtonInactiveFLI);
       jpanel1.add(radioButtonInactiveFLI,cc.xy(4,8));

       radioButtonActiveFLI.setActionCommand("Active");
       radioButtonActiveFLI.setName("radioButtonActiveFLI");
       radioButtonActiveFLI.setText("Active");
       buttongroupFLI.add(radioButtonActiveFLI);
       jpanel1.add(radioButtonActiveFLI,cc.xy(5,8));

       spinnerToleranceFLI.setName("spinnerToleranceFLI");
       jpanel1.add(spinnerToleranceFLI,cc.xy(7,8));

       labelToleranceFLI.setName("labelToleranceFLI");
       labelToleranceFLI.setText("% tolerance");
       jpanel1.add(labelToleranceFLI,cc.xy(8,8));

       radioButtonInactiveMoonDistance.setActionCommand("Inactive");
       radioButtonInactiveMoonDistance.setName("radioButtonInactiveMoonDistance");
       radioButtonInactiveMoonDistance.setText("Inactive");
       buttongroupMoonD.add(radioButtonInactiveMoonDistance);
       jpanel1.add(radioButtonInactiveMoonDistance,cc.xy(4,9));

       radioButtonActiveMoonDistance.setActionCommand("Active");
       radioButtonActiveMoonDistance.setName("radioButtonActiveMoonDistance");
       radioButtonActiveMoonDistance.setText("Active");
       buttongroupMoonD.add(radioButtonActiveMoonDistance);
       jpanel1.add(radioButtonActiveMoonDistance,cc.xy(5,9));

       spinnerToleranceMoonDistance.setName("spinnerToleranceMoonDistance");
       jpanel1.add(spinnerToleranceMoonDistance,cc.xy(7,9));

       labelToleranceMoonDistance.setName("labelToleranceMoonDistance");
       labelToleranceMoonDistance.setText("% tolerance");
       jpanel1.add(labelToleranceMoonDistance,cc.xy(8,9));

       labelSunAngle.setName("labelSunAngle");
       labelSunAngle.setText("Sun Elevation");
       jpanel1.add(labelSunAngle,cc.xy(2,10));

       radioButtonInactiveSunAngle.setActionCommand("Inactive");
       radioButtonInactiveSunAngle.setName("radioButtonInactiveSunAngle");
       radioButtonInactiveSunAngle.setText("Inactive");
       buttongroupSun.add(radioButtonInactiveSunAngle);
       jpanel1.add(radioButtonInactiveSunAngle,cc.xy(4,10));

       radioButtonActiveSunAngle.setActionCommand("Active");
       radioButtonActiveSunAngle.setName("radioButtonActiveSunAngle");
       radioButtonActiveSunAngle.setText("Active");
       buttongroupSun.add(radioButtonActiveSunAngle);
       jpanel1.add(radioButtonActiveSunAngle,cc.xy(5,10));

       spinnerToleranceSunAngle.setName("spinnerToleranceSunAngle");
       jpanel1.add(spinnerToleranceSunAngle,cc.xy(7,10));

       labelToleranceSunAngle.setName("labelToleranceSunAngle");
       labelToleranceSunAngle.setText("degrees");
       jpanel1.add(labelToleranceSunAngle,cc.xy(8,10));

       labelMoonAngle.setName("labelMoonAngle");
       labelMoonAngle.setText("Moon Elevation");
       jpanel1.add(labelMoonAngle,cc.xy(2,11));

       radioButtonInactiveMoonAngle.setActionCommand("Inactive");
       radioButtonInactiveMoonAngle.setName("radioButtonInactiveMoonAngle");
       radioButtonInactiveMoonAngle.setText("Inactive");
       buttongroupMoonA.add(radioButtonInactiveMoonAngle);
       jpanel1.add(radioButtonInactiveMoonAngle,cc.xy(4,11));

       radioButtonActiveMoonAngle.setActionCommand("Active");
       radioButtonActiveMoonAngle.setName("radioButtonActiveMoonAngle");
       radioButtonActiveMoonAngle.setText("Active");
       buttongroupMoonA.add(radioButtonActiveMoonAngle);
       jpanel1.add(radioButtonActiveMoonAngle,cc.xy(5,11));

       spinnerToleranceMoonAngle.setName("spinnerToleranceMoonAngle");
       jpanel1.add(spinnerToleranceMoonAngle,cc.xy(7,11));

       labelToleranceMoonAngle.setName("labelToleranceMoonAngle");
       labelToleranceMoonAngle.setText("degrees");
       jpanel1.add(labelToleranceMoonAngle,cc.xy(8,11));

       JLabel jlabel1 = new JLabel();
       jlabel1.setText("Moon distance");
       jpanel1.add(jlabel1,cc.xy(2,9));

       JLabel jlabel2 = new JLabel();
       jlabel2.setText("Time Interval");
       jlabel2.setToolTipText("User Defined Time Interval");
       jpanel1.add(jlabel2,cc.xy(2,14));

       JLabel jlabel3 = new JLabel();
       jlabel3.setText("Sidereal Time Interval");
       jlabel3.setToolTipText("User Defined Time Interval");
       jpanel1.add(jlabel3,cc.xy(2,15));

       radioButtonInactiveTimeInterval.setActionCommand("Inactive");
       radioButtonInactiveTimeInterval.setName("radioButtonInactiveTimeInterval");
       radioButtonInactiveTimeInterval.setText("Inactive");
       buttongroupTimeInt.add(radioButtonInactiveTimeInterval);
       jpanel1.add(radioButtonInactiveTimeInterval,cc.xy(4,14));

       radioButtonActiveTimeInterval.setActionCommand("Active");
       radioButtonActiveTimeInterval.setName("radioButtonActiveTimeInterval");
       radioButtonActiveTimeInterval.setText("Active");
       buttongroupTimeInt.add(radioButtonActiveTimeInterval);
       jpanel1.add(radioButtonActiveTimeInterval,cc.xy(5,14));

       radioButtonInactiveSidTimeInt.setActionCommand("Inactive");
       radioButtonInactiveSidTimeInt.setName("radioButtonInactiveSidTimeInt");
       radioButtonInactiveSidTimeInt.setText("Inactive");
       buttongroupSidTimeInt.add(radioButtonInactiveSidTimeInt);
       jpanel1.add(radioButtonInactiveSidTimeInt,cc.xy(4,15));

       radioButtonActiveSidTimeInt.setActionCommand("Active");
       radioButtonActiveSidTimeInt.setName("radioButtonActiveSidTimeInt");
       radioButtonActiveSidTimeInt.setText("Active");
       buttongroupSidTimeInt.add(radioButtonActiveSidTimeInt);
       jpanel1.add(radioButtonActiveSidTimeInt,cc.xy(5,15));

       labelAirmass.setName("labelAirmass");
       labelAirmass.setText("Airmass");
       jpanel1.add(labelAirmass,cc.xy(2,6));

       spinnerToleranceAirmass.setName("spinnerToleranceAirmass");
       jpanel1.add(spinnerToleranceAirmass,cc.xy(4,6));

       labelToleranceAirmass.setName("labelToleranceAirmass");
       labelToleranceAirmass.setText("% tolerance");
       jpanel1.add(labelToleranceAirmass,cc.xy(5,6));

       labelInfo.setName("labelInfo");
       labelInfo.setText("0 Observation blocks loaded");
       jpanel1.add(labelInfo,cc.xy(2,20));

       jpanel1.add(WizardTitlePanel.createPanel(),cc.xywh(1,1,11,1));
       JLabel jlabel4 = new JLabel();
       jlabel4.setText("Zenith Contraint");
       jlabel4.setToolTipText("");
       jpanel1.add(jlabel4,cc.xy(2,17));

       radioButtonInactiveZenith.setActionCommand("Inactive");
       radioButtonInactiveZenith.setName("radioButtonInactiveZenith");
       radioButtonInactiveZenith.setText("Inactive");
       buttongroupZenith.add(radioButtonInactiveZenith);
       jpanel1.add(radioButtonInactiveZenith,cc.xy(4,17));

       radioButtonActiveZenith.setActionCommand("Active");
       radioButtonActiveZenith.setName("radioButtonActiveZenith");
       radioButtonActiveZenith.setText("Active");
       buttongroupZenith.add(radioButtonActiveZenith);
       jpanel1.add(radioButtonActiveZenith,cc.xy(5,17));

       addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7,8,9,10,11 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 });
       return jpanel1;
    }

  

    /**
     * Initializer
     */
    protected void initializePanel() {
    	setLayout(new BorderLayout());
    	add(createPanel(), BorderLayout.CENTER);
    	
    	spinnerToleranceAirmass.setModel(new SpinnerNumberModel(0, 0, 100, 1));
    	spinnerToleranceFLI.setModel(new SpinnerNumberModel(0, 0, 100, 1));
    	spinnerToleranceMoonDistance.setModel(new SpinnerNumberModel(0, 0, 100, 1));
    	spinnerToleranceMoonAngle.setModel(new SpinnerNumberModel(0, -180, +180, 1));
    	spinnerToleranceSunAngle.setModel(new SpinnerNumberModel(0, -180, +180, 1));
    	
    	listenTo(spinnerToleranceAirmass);
    	listenTo(spinnerToleranceFLI);
    	listenTo(spinnerToleranceMoonDistance);
    	listenTo(spinnerToleranceMoonAngle);
    	listenTo(spinnerToleranceSunAngle);
    	spinnerToleranceSunAngle.setValue(new Integer(-18));
    	
    	
    	listenTo(radioButtonInactiveFLI);
    	listenTo(radioButtonInactiveMoonDistance);
        listenTo(radioButtonInactiveSunAngle);
        listenTo(radioButtonInactiveMoonAngle);
        listenTo(radioButtonInactiveTimeInterval);
        listenTo(radioButtonInactiveSidTimeInt);
        listenTo(radioButtonInactiveZenith);

        listenTo(radioButtonActiveFLI);
        listenTo(radioButtonActiveMoonDistance);
        listenTo(radioButtonActiveSunAngle);
        listenTo(radioButtonActiveMoonAngle);
        listenTo(radioButtonActiveTimeInterval);
        listenTo(radioButtonActiveSidTimeInt);
        listenTo(radioButtonActiveZenith);
          
        radioButtonActiveFLI.setSelected(true);
        radioButtonActiveMoonDistance.setSelected(true);
        radioButtonActiveSunAngle.setSelected(true);
        radioButtonActiveMoonAngle.setSelected(true);
        radioButtonInactiveTimeInterval.setSelected(true);
        radioButtonInactiveSidTimeInt.setSelected(true);  
        radioButtonActiveZenith.setSelected(true);  
               
        radioButtonActiveFLI.doClick();
        radioButtonActiveMoonDistance.doClick();
        radioButtonActiveSunAngle.doClick();
        radioButtonActiveMoonAngle.doClick();
        radioButtonInactiveTimeInterval.doClick();
        radioButtonInactiveSidTimeInt.doClick();
        radioButtonActiveZenith.doClick();

      
    }

  

    protected boolean isReady() {
        boolean result = false;    
        
        if (buttongroupFLI.getSelection() != null
                && buttongroupMoonD.getSelection() != null
                && buttongroupSun.getSelection() != null
                && buttongroupMoonA.getSelection() != null
                && buttongroupTimeInt.getSelection() != null
                && buttongroupZenith.getSelection() != null
                    && buttongroupSidTimeInt.getSelection() != null) {
            result = true;
        }
        
        return result;
    }
    
    public void setInfo(String info) {
    	this.labelInfo.setText(info);
    }

  
}
