package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;

/**
 * 
 *
 * <p>
 * $Id: ViewEphFileAction.java,v 1.5 2005/02/11 10:31:49 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public class ViewEphFileAction extends ActionSuperclass {

    private ObjectContainer objectContainer_;
    
    private Media device_;
    
    private static TextDisplayWidget log_ =
        new TextDisplayWidget("View Ephemeris File");


    /**
     * Constructs a ShowDetailsAction action.
     */

    public ViewEphFileAction(ObjectContainer objectContainer,Media device) {
        super((JComponent) objectContainer,"View Ephemeris File");
        objectContainer_ = objectContainer;
        device_ = device;
    }

    /**
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
        Long[] idLongs = null;
        Long idLong = objectContainer_.getSelected();
        ObjectManager objMgr = ObjectManager.getObjectManager();

        ObservationBlock ob;
        
        try {
            ob =
                (ObservationBlock)objMgr.getBusObj(
                    device_,
                    idLong.longValue(),
                    ObservationBlock.class);
            if(!ob.hasEphemerisFile()) {
                JOptionPane.showMessageDialog(
                        objectContainer_.getTopLevelAncestor(),
                        new Object[] { "No Ephemeris file attached" },
                        "No Ephemeris File Attached",
                        JOptionPane.ERROR_MESSAGE);
                    return;
            }
            
            log_.clearTextArea();
            log_.setTextArea(ob.getEphemerisFile().getFileString());
            log_.setVisible(true);
        } catch (ObjectNotFoundException e) {
             announceNoObject(e);
        } catch (ObjectIOException e) {
             announceIOError(e);
        } 
    }
}
