package org.eso.ohs.phase2.apps.p2ppAppServer;

import java.sql.SQLException;

import org.eso.ohs.core.dbb.server.DbbSession;
import org.eso.ohs.core.dbb.server.DbbSqlEngine;
import org.eso.ohs.core.dbb.server.DbbSqlEngineImpl;
import org.eso.ohs.core.dbb.sql.DbbSqlTable;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.persistence.Config;

/*
 * Created on Apr 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * Class Phase1BrowserConfig
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.1 $
 * @author tcanavan, Apr 25, 2005
 */

// $Id: Phase1BrowserConfig.java,v 1.1 2005/04/25 16:40:48 tcanavan Exp $
public class Phase1BrowserConfig {
    
    private final static  String DBASE_NAME = Config.getCfg().getDbName(
            ObservingRun.getSuffix());

    
    public static String colProgId  = "programme_id";

    public static DbbSqlTable getTargetTable() {
    return new DbbSqlTable(DBASE_NAME, "", "targets");
    }

    public static DbbSqlTable getSchedRepTable() {
    return new DbbSqlTable(DBASE_NAME, "", "sched_rep");
    }

    public static DbbSqlTable getObsRunsTable() {
    return new DbbSqlTable(DBASE_NAME, "", "obs_runs");
    }

    // Connect to the database (define a session)
    public static DbbSqlEngine getDbbSqlEngine()
                    throws SQLException {
    return getDbbSqlEngine(getTargetTable(), getSchedRepTable(), getObsRunsTable());
    }


    // Connect to the database (define a session)
    public static DbbSqlEngine getDbbSqlEngine(DbbSqlTable targets,
                        DbbSqlTable schedRep, 
                        DbbSqlTable obsRuns)
    throws SQLException {

    Config      cfg = Config.getCfg();
    DbbSession session
        = new DbbSession(cfg.getUrl(ObservationBlock.getSuffix()),
                  DBASE_NAME,
                  cfg.getDbUserName(),
                  cfg.getDbPassword());

    DbbSqlEngineImpl sqleImpl = new DbbSqlEngineImpl(session,false);

//  System.out.println("Engine: "+sqleImpl);
    sqleImpl.addJoinCondition(obsRuns,colProgId,targets,colProgId);
    sqleImpl.addJoinCondition(obsRuns,"id",schedRep,"run_id");

//  System.out.println("getDbbSqlEngine DONE");
    return sqleImpl;
    }

}
