package org.eso.ohs.phase2.icdVcs;

import java.sql.SQLException;

import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.OHSApplication;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.dbase.phase2.OBHistory;

/**
 * @author tcanavan
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ProcessOBStatusEvents implements Runnable {

    private String BOBEventType;

    private String idstr;

    public ProcessOBStatusEvents(String BOBEventType, String idstr) {
        this.BOBEventType = BOBEventType;
        this.idstr = idstr;
    }

    /**
     * @see java.lang.Runnable#run()
     */
    public void run() {
        ObjectManager objMgr = ObjectManager.getObjectManager();
        String status = CalibrationBlock.convertBobEventToStatus(BOBEventType);
        long id = Long.valueOf(idstr).longValue();
        CalibrationBlock cb = null;
        CalibrationBlock dbCb = null;
        Class c = CalibrationBlock.class;
        if (id < 0) {
            c = Config.getCfg().getClassFromId(id);
            try {
                cb = (CalibrationBlock) objMgr.getBusObj(Media.LOCAL, id, c);
            } catch (ObjectNotFoundException e) {
                e.printStackTrace();
                ErrorMessages.announceNoObject(null, e);

            } catch (ObjectIOException e) {
                e.printStackTrace();
                ErrorMessages.announceIOError(null, e);
            }
        } else {
            try {
                dbCb =
                    (CalibrationBlock) objMgr.getBusObj(
                        Media.DBASE,
                        Config.getCfg().tableToUniqueId(
                            id,
                            ObservationBlock.class),
                        ObservationBlock.class);
                cb =
                    (CalibrationBlock) objMgr.getBusObj(
                        Media.LOCAL,
                        dbCb.getCloneParentId(),
                        ObservationBlock.class);
            } catch (ObjectNotFoundException e) {
                try {
                    dbCb =
                        (CalibrationBlock) objMgr.getBusObj(
                            Media.DBASE,
                            Config.getCfg().tableToUniqueId(
                                id,
                                CalibrationBlock.class),
                            CalibrationBlock.class);
                    cb =
                        (CalibrationBlock) objMgr.getBusObj(
                            Media.LOCAL,
                            dbCb.getCloneParentId(),
                            CalibrationBlock.class);
                } catch (ObjectNotFoundException e1) {
                    e1.printStackTrace();
                    ErrorMessages.announceNoObject(null, e1);
                } catch (ObjectIOException e2) {
                    e2.printStackTrace();
                    ErrorMessages.announceIOError(null, e2);
                }
            } catch (ObjectIOException e3) {
                e3.printStackTrace();
                ErrorMessages.announceIOError(null, e3);
            }
        }
        cb.setStatus(status);
        objMgr.queueObject(cb);
        if (IcdVcsCfg.getCfg().isInVisitorMode()
            || (IcdVcsCfg.getCfg().isInEngineeringMode()
                && IcdVcsCfg.getCfg().isInCloneMode())) {
            dbCb.setStatus(status);
            objMgr.queueObject(dbCb);
            try {
                OBHistory.addEvent(
                    Config.getCfg().uniqueToTableId(dbCb.getId()),
                    null,
                    OHSApplication.getShortDesc(),
                    new Integer(Config.getCfg().getUserName()).toString(),
                    cb.getStatus());
            } catch (SQLException e) {
                ErrorMessages.announceIOError(null, e);
            }
        }
    }

}
